/***********************************************************************/

import java.io.*;
import java.util.*;

/**
 * Classe che ingloba un file e permette di leggere e aggiungere ad
 * una biblioteca un elenco di libri precedentemente scritto su file.
 */

public class BiblioReader extends MyReader 
{
//  private Biblioteca biblioteca; // dove sono aggiunti i libri letti

/** Apre file con nome dato e crea reader su quel file */
  public BiblioReader(String name) throws IOException //, Biblioteca bib) throws IOException
  {  super(name); /* biblioteca = bib;*/ }

/** Crea reader file gia' aperto */
  public BiblioReader(InputStream ffdd) //, Biblioteca bib)
  {  super(ffdd); } //biblioteca = bib;  }

/** Legge libro e lo aggiunge alla biblioteca, ritorna true se tutto
 *  ok e false altrimenti.
 */
  public boolean readBook(Biblioteca bib)
  {
    StringBuffer sAut = new StringBuffer();
    StringBuffer sTit = new StringBuffer();
    String aut, tit, s;
    int n, p, i;
    try
    {
      s = readString();
      if (!isKeyword(s,BiblioIO.AUT)) return false;
      s = readString();
      while (!isKeyword(s,BiblioIO.TIT))
      {  sAut.append(" "); sAut.append(s); s = readString();  }
      aut = new String(sAut); aut = aut.trim();
      if (aut.length()==0) return false;
      s = readString();
      while (!isKeyword(s,BiblioIO.NUM))
      {  sTit.append(" "); sTit.append(s); s = readString();  }
      tit = new String(sTit); tit = tit.trim();
      if (tit.length()==0)  return false;
      n = readInteger();
      if (n==0) return false;
      s = readString();
      if (!isKeyword(s,BiblioIO.PST)) return false;
      p = readInteger();
      if (!bib.nuovoLibro(aut,tit,n)) return false;
      for (i=0; i<p; i++)  bib.prestaLibro(bib.numeroLibri()-1);
      return true;
    }
    catch (Exception exc)
    {  return false;  }
  } 

/** Legge e aggiunge alla biblioteca tutti i libri che trova sul file,
    ritorna il loro numero. */
  public int read(Biblioteca bib)
  {
    String s = null;
    try { s = readString(); } catch (Exception exc) {}
    if (!isKeyword(s,BiblioIO.KEY_WORD)) return 0; // manca parola chiave
    int c = 0;
    try { c = readInteger(); } catch (Exception exc) {}
    bib.cambiaCapacita(c);
    int n = 0;
    while (readBook(bib)) { n++; }
    return n;
  } 

  public static void main(String[] args)
  {
    Biblioteca b = new Biblioteca();
    try 
    {  BiblioReader br = new BiblioReader("pippo.txt");
       br.read(b);
    }
    catch (Exception exc) {}
    try
    {  BiblioWriter bw = new BiblioWriter(System.out);
       bw.write(b);
    }
    catch (Exception exc) {}
  }
};

/***********************************************************************/
