import java.awt.*;
import java.awt.event.*;

/**
 * Classe che realizza finestra di dialogo con solo un bottone ok
 * nella parte inferiore, ma predisposta a contenere altre cose nelle
 * parti superiore e centrale.
 */

public class Dialog1 extends Dialog
{
/** bottone Ok in fondo alla finestra */
  protected Button bOk;

/** pannello superiore, non usato per adesso */
  protected Panel pSopra;
/** pannello inferiore, usato per contenere bottone Ok */
  protected Panel pSotto;
/** pannello centrale, non usato per adesso */
  protected Panel pCentro;

/** riferimento a questa finestra, serve per i listener */
  protected Dialog thisDialog;

/** listener che mostra questa finestra */
  protected ActionListener hideMe = new ActionListener()
    {
	public void actionPerformed(ActionEvent event)
        {  thisDialog.setVisible(false);  }
    };
/** listener che nasconde questa finestra **/
  protected ActionListener showMe = new ActionListener()
    {
	public void actionPerformed(ActionEvent event)
        {  thisDialog.setVisible(true);  }
    };

/**
 * Costruisce la finestra di dialogo dal punto 
 * di vista del contenuto grafico, senza comportamento.
 */
  protected void costruisci()
  {
    setLayout(new BorderLayout());
    bOk = new Button("ok");
    pSotto = new Panel();
    pSotto.setLayout(new FlowLayout());
    pSotto.add(bOk);
    add(pSotto,BorderLayout.SOUTH);
    pCentro = null;
    pSopra = null;
    thisDialog = this;
  }

/**
 * Costruisce finestra di dialogo dati la finestra da cui dipende,
 * il titolo da mettere nella barra del titolo,
 * flag se la finestra di dialogo sia modale on no.
 * @see Dialog1#costruisci
 */
  public Dialog1(Frame f, String title, boolean modal)
  {
    super(f,title,modal);
    costruisci();
    pack();
  }

/** Aggiunge comportamento per il bottone bOk. */
  public void addOkListener(ActionListener l)
  {  bOk.addActionListener(l);  }

/** Ritorna comportamento di nascondere questa finestra,
    deve essere associato a qualche bottone su questa finestra. */
  ActionListener hideListener() {  return hideMe;  }

/** Ritorna comportamento di mostrare questa finestra, deve
    essere associato ad un componente sulla finestra principale. */
  ActionListener showListener() {  return showMe;  }

/** Funzione main di prova. */
  public static void main(String[] args)
  {
    /* crea frame f con bottone b */
    final Frame f = new Frame();
    final Button b = new Button("Apri Dialog 1");
    f.add(b);
    f.pack();
    /* crea dialogo d dipendente da f su biblioteca nuova */
    final Dialog1 d = new Dialog1(f,"Dialog 1",true);
    /* bottone b su frame f mostra dialogo d */
    b.addActionListener(d.showListener());
    /* bottone ok su d nasconde d */
    d.addOkListener(d.hideListener());
    /* mostra a schermo il frame */
    f.setVisible(true);
  }

}

