import java.awt.*;
import java.awt.event.*;

/**
 * Finestra di dialogo con due bottoni Ok, Canc nella parte inferiore,
 * e nella parte centrale pannello con quattro campi di testo per
 * codice, autore, titolo, numero copie di un libro
 * (ogni campo di testo e' accompagnato da un'etichetta esplicativa),
 * la parte superiore invece non e' usata.
*/

public class Dialog2 extends Dialog1
{
/** bottone Canc in fondo alla finestra */
  protected Button bCanc;
/** campo di testo per autore del libro */
  public TextField tAut; 
/** campo di testo per titolo del libro */
  public TextField tTit;
/** campo di testo per numero di copie del libro */
  public TextField tCop;

/**
 * Costruisce la finestra di dialogo dal punto 
 * di vista del contenuto grafico, senza comportamento.
 */
  protected void costruisci()
  {
    super.costruisci();
    // aggiunge bottone al pannello centrale
    bCanc = new Button("Canc");
    pSotto.add(bCanc);
    // pannello centrale e' diviso in 
    // altri 2 pannelli ciascuno a griglia
    pCentro = new Panel(new BorderLayout());
    add(pCentro,BorderLayout.CENTER);
    Panel pCentroSx = new Panel(new GridLayout(3,1));
    Panel pCentroDx = new Panel(new GridLayout(3,1));
    pCentro.add(BorderLayout.WEST,pCentroSx);
    pCentro.add(BorderLayout.CENTER,pCentroDx);
    // contenuto dei due sotto-pannelli
    pCentroSx.add(new Label("Autore:"));
    pCentroDx.add(tAut = new TextField(20));
    pCentroSx.add(new Label("Titolo:"));
    pCentroDx.add(tTit = new TextField(30));
    pCentroSx.add(new Label("Copie:"));
    pCentroDx.add(tCop = new TextField(10));
  }

/**
 * Costruisce finestra di dialogo dati la finestra da cui dipende,
 * il titolo da mettere nella barra del titolo,
 * flag se la finestra di dialogo sia modale on no.
 * @see Dialog2#costruisci
 */
  public Dialog2(Frame f, String title, boolean modal)
  {  super(f,title,modal);  }

/** Svuota tutti i campi di testo. */
  void pulisci()
  {  tAut.setText(""); tTit.setText(""); tCop.setText("");  }


/** Aggiunge comportamento al bottone bCanc. */  
  public void addCancListener(ActionListener l)
  {  bCanc.addActionListener(l);  }

  public static void main(String[] args)
  {
    /* crea frame f con bottone b */
    final Frame f = new Frame();
    final Button b = new Button("Apri Dialog 2");
    f.add(b);
    f.pack();
    /* crea dialogo d dipendente da f */
    final Dialog2 d = new Dialog2(f,"Dialog 2",true);
    /* bottone b su frame f mostra dialogo d */
    b.addActionListener(d.showListener());
    /* bottone ok su d stampa stringa e nasconde d */
    d.addOkListener(new ActionListener()
      {  public void actionPerformed(ActionEvent e)
         {  System.out.println("Immessi autore=" + d.tAut.getText() + 
                               " titolo=" + d.tTit.getText() +
                               " copie=" + d.tCop.getText());
            d.setVisible(false);
         }
      });
    /* bottone canc su d nasconde d senza far nulla */
    d.addCancListener(d.hideListener());
    /* mostra a schermo il frame */
    f.setVisible(true);
  }

}


