import java.awt.event.*;
import java.awt.*;

public class ExImage extends Panel
{
  Image image;
  int width = 0;
  int height = 0;

  public ExImage (Image img)
  {
    image = img;
    width = image.getWidth(this);
    height = image.getHeight(this);
  }

  public ExImage (String fileImmagine)
  {
    image = loadImage(fileImmagine);
    width = image.getWidth(this);
    height = image.getHeight(this);
  }

  Image loadImage(String fileImmagine)
  {
    Toolkit tool = Toolkit.getDefaultToolkit();
    Image img = tool.getImage(fileImmagine);
    try 
    {  MediaTracker track = new MediaTracker(this);
       track.addImage(img,0);
       track.waitForID(0);
    }
    catch (InterruptedException e)
    {  System.out.println("Image not loaded");  }
    /* importante: se non avessi usato il MediaTracker
       ora l'immagine potrebbe non essere ancora stata caricata del
       tutto e quindi width e height potrebbero risultare -1 */
    return img;
  }

  public void paint(Graphics g)
  {
    super.paint(g);
    g.drawImage (image, 0, 0, width, height, this);
  }

  public Dimension getPreferredSize ()
  {  return new Dimension (width, height);  }

  public static void main(String[] args)
  {
    Frame f = new Frame();
    f.setLayout(new FlowLayout());
    ExImage ei = new ExImage("pallini.gif");
    f.add(ei);
    f.pack();
    f.setVisible(true); 
  }

}
