/**
 * Classe che implementa un libro all'interno della biblioteca:
 * oltre ad autore e titolo ereditati dalla super-classe Libro,
 * vi sono il numero di copie totali che la biblioteca possiede e 
 * il numero di queste che sono attualmente in prestito.
 */

public class LibroInBiblioteca extends Libro
{
  private int totali;      // numero totale di copie presenti
  private int prestate;    // numero di copie prestate

/** Costruisce nuovo libro con autore, titolo e numero di copie totali
 *  dati, mentre il numero di copie prestate e' inizialmente zero.
 *  @param   aut   autore del nuovo libro
 *  @param   tit   titolo del nuovo libro
 *  @param   num   numero di copie totali del nuovo libro
 */
  public LibroInBiblioteca(String aut, String tit, int num)
  {  super(aut,tit); totali = num; prestate = 0;  }

/** Fornisce numero di copie del libro possedute dalla biblioteca. */
  public int copieTotali() {  return totali;  }

/** Fornisce numero di copie del libro prestate */
  public int copiePrestate() {  return prestate;  }

/** Presta una copia del libro, solo se esistono copie non prestate.
 *  @return   true in caso di successo, false altrimenti
 */
  public boolean presta()
  {  if (prestate<totali) {  prestate++; return true; }
     else return false;
  }

/** Restituisce una copia del libro, solo se esistono copie prestate.
 *  @return   true in caso di successo, false altrimenti
 */
  public boolean restituisci()
  {  if (prestate>0) {  prestate--; return true; }
     else return false;
  }
}
